/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2020 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */



#include "../Sample/kwaiatek_usycha_8bit_8kHz_raw.h"
#define	SAMPLE_ku_OFS		0 //0xAA
#define	SAMPLE_ku_DATA		kwaiatek_usycha_8bit_8kHz_raw
#define	SAMPLE_ku_LEN		(kwaiatek_usycha_8bit_8kHz_raw_size - SAMPLE_ku_OFS)


/*
#include "../Sample/sucho8.h"
#define	SAMPLE_s_OFS		0xA0
#define	SAMPLE_s_DATA		sucho8_wav
#define	SAMPLE_s_LEN		(sucho8_wav_size - SAMPLE_s_OFS)

#include "../Sample/mokro8.h"
#define	SAMPLE_m_OFS		0xA0
#define	SAMPLE_m_DATA		mokro8_wav
#define	SAMPLE_m_LEN		(mokro8_wav_size - SAMPLE_m_OFS)
#include "../Sample/alarm8.h"
#define	SAMPLE_a_OFS		0xA0
#define	SAMPLE_a_DATA		alarm8_wav
#define	SAMPLE_a_LEN		(alarm8_wav_size - SAMPLE_a_OFS)
*/



#define BkpCrc              TAMP->TAMP_BKP0R
#define BkpPrevStan			TAMP->TAMP_BKP1R
#define BkpCnt				TAMP->TAMP_BKP2R


/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
IWDG_HandleTypeDef hiwdg;

TIM_HandleTypeDef htim3;
TIM_HandleTypeDef htim14;

/* USER CODE BEGIN PV */


#define	LICZBA_POMIAROW		(1 << 3)		// 8 pomiarow do usrednienia
enum{ FAZA_LADOWANIA, FAZA_ROZLADOWANIA };
uint8_t fazaPomiaru;
uint16_t volatile CzasLadowania, CzasRozladowania;
uint16_t volatile SredniaLadowania, SredniaRozladowania;

void irqWejsciePomiarowe(){
	uint8_t static nrPomiaru = LICZBA_POMIAROW;

	//if( HAL_GPIO_ReadPin( GPIOC, GPIO_PIN_14 ) )
	{
		if( fazaPomiaru ==  FAZA_LADOWANIA) {
			CzasLadowania = TIM14->CNT;
			uint32_t static srednia;
			srednia += CzasLadowania;
			if( ! nrPomiaru ){
				SredniaLadowania = srednia / LICZBA_POMIAROW;
				srednia = 0;
				__NOP();
			}
			__NOP();
		}
	}
	//else
	{
		if( fazaPomiaru ==  FAZA_ROZLADOWANIA) {
			CzasRozladowania = TIM14->CNT;
			uint32_t static srednia;
			srednia += CzasRozladowania;
			if( ! nrPomiaru ){
				SredniaRozladowania = srednia / LICZBA_POMIAROW;
				srednia = 0;
				__NOP();
			}
			__NOP();
		}
	}
	nrPomiaru--;
	nrPomiaru &= LICZBA_POMIAROW-1;
}


uint8_t *pSample;				// Wskaźnik na sample
uint16_t lenSample;				// Długość sampli
uint8_t volatile stanSample;	// 1-trwa odtwarzanie
void irqPlaySample(){


	if( ! stanSample ) return;


	uint8_t static div;
	if( --div == 0 ) {
//		div = 16;		// 16MHz / 16 / 2 (time pwm) = 7`812,5Hz
		div = 4;		// 16MHz / 4 / 2 (time pwm) = 7`812,5Hz

		uint8_t pwm = *pSample++;
		if( pwm & 0x80 ){		// Konwersja U8 na I8
			pwm = ~pwm;
			pwm++;
		}
		__HAL_TIM_SET_COMPARE(&htim3, TIM_CHANNEL_3, pwm );

		//pwm = smp << 5;		// 7`812,5Hz / 2^(8-5) = 976,5625Hz
		//__HAL_TIM_SET_COMPARE(&htim3, TIM_CHANNEL_3, pwm );

		if( --lenSample == 0 ) stanSample=0;
	}
}


uint16_t volatile timPlayPause, timDelayPomiar;
void irq1ms(){
	if( timPlayPause ) timPlayPause--;
	if( timDelayPomiar ) timDelayPomiar--;
}


uint8_t poziomCieczy;
long map(long x, long in_min, long in_max, long out_min, long out_max) {
  return (x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min;
}


/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_IWDG_Init(void);
static void MX_TIM3_Init(void);
static void MX_TIM14_Init(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

	//----- Zatrzymuj IWDG podczas debugowania -----//
	__HAL_DBGMCU_FREEZE_IWDG(); // DBGMCU -> APB1FZ |= DBGMCU_APB1_FZ_DBG_IWDG_STOP;
	//__HAL_FREEZE_WWDG_DBGMCU

	//----- Nie rozlaczaj z debugerem po usypieniu, stop, itp
	//DBGMCU->CR |= DBGMCU_CR_DBG_SLEEP | DBGMCU_CR_DBG_STOP | DBGMCU_CR_DBG_STANDBY;   //

	// __HAL_DBGMCU_FREEZE_TIM1();
	// __HAL_DBGMCU_FREEZE_TIM2();
	//__HAL_DBGMCU_FREEZE_TIM12();

	//----- Flaga wybudzenia -----//
	//if ( __HAL_PWR_GET_FLAG(PWR_FLAG_WU) ) FL_WakeUp = 1;
	//__HAL_PWR_CLEAR_FLAG(PWR_FLAG_WU);    // INFO: bez tego nie da sie wypudzic CPU
	//if ( __HAL_PWR_GET_FLAG(PWR_FLAG_WUF1) ) FL_WakeUp = 1;
	__HAL_PWR_CLEAR_FLAG(PWR_FLAG_WUF1);    // INFO: bez tego nie da sie wypudzic CPU


    // Enable access to Backup domain
    HAL_PWR_EnableBkUpAccess();
    //BkpCnt++;

    // Reset Backup domain
    //__HAL_RCC_BACKUPRESET_FORCE();
    //__HAL_RCC_BACKUPRESET_RELEASE();
    __NOP();

    //__IO uint32_t RAM2 0x20000000;

  /* USER CODE END 1 */
  

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_IWDG_Init();
  MX_TIM3_Init();
  MX_TIM14_Init();
  /* USER CODE BEGIN 2 */

  //----- Pomiar czasu
  HAL_TIM_Base_Start(&htim14);

  //----- Audio
  HAL_TIM_Base_Start_IT(&htim3);
  //HAL_TIM_PWM_Start_IT(&htim3, TIM_CHANNEL_3);
  HAL_TIM_PWM_Start(&htim3, TIM_CHANNEL_3);


  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  // LOOP:
  while (1)
  {
	  HAL_IWDG_Refresh(&hiwdg);
	  __WFI();

    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */


	  uint8_t static sucho;


	  //----- Ppomiar wilgotności -----//
	  if( ! timDelayPomiar ){
		  timDelayPomiar = 1000;


		  for( uint8_t x=0; x<LICZBA_POMIAROW; x++){
			  //----- Przygotowanie pomiaru - Rozładowanie pojemności -----//
			  HAL_GPIO_WritePin( LD2_GPIO_Port, LD2_Pin, GPIO_PIN_RESET );
			  HAL_Delay( 1 );

			  //----- ładowanie pojemności
			  fazaPomiaru = FAZA_LADOWANIA;
			  TIM14->CNT = 0;
			  HAL_GPIO_WritePin( LD2_GPIO_Port, LD2_Pin, GPIO_PIN_SET );
			  HAL_Delay( 1 );

			  //----- Rozładowanie pojemności -----//
			  fazaPomiaru = FAZA_ROZLADOWANIA;
			  TIM14->CNT = 0;
			  HAL_GPIO_WritePin( LD2_GPIO_Port, LD2_Pin, GPIO_PIN_RESET );
			  HAL_Delay( 1 );

		  }


		  __NOP();
		  if( SredniaLadowania < 500 ) {
			  __NOP();
			  sucho = 1;
		  }
		  else if ( SredniaLadowania > 700 ){
			  __NOP();
			  sucho = 0;
		  }
		  __NOP();



		  poziomCieczy = map( SredniaLadowania, 174, 1560, 0, 100);
		  if( poziomCieczy < 10 ){
			  __NOP();
		  }
		  __NOP();
	  }


	  //----- Sygnalizacja na LED -----//
	  if( sucho ) HAL_GPIO_WritePin( LD2_GPIO_Port, LD2_Pin, GPIO_PIN_RESET );
	  else HAL_GPIO_WritePin( LD2_GPIO_Port, LD2_Pin, GPIO_PIN_SET );


	  //----- Odtwarzanie sampli -----//
	  if( sucho ){
		  if( ! stanSample && !timPlayPause ){						// Gdy koniec odtwarzania
			  timPlayPause = 5000;


			  pSample = (uint8_t *)SAMPLE_ku_DATA;	// Adres sampli
			  pSample += SAMPLE_ku_OFS;				// Ofset pliku WAV
			  lenSample = SAMPLE_ku_LEN;			// Dlugość
			  stanSample = 1;
/*
			  uint8_t static nrKomunikatu;
			  switch( nrKomunikatu ){
			  case 0:
			  //pSample = (uint8_t *)SAMPLE_m_DATA;	// Adres sampli
			  //pSample += SAMPLE_m_OFS;				// Ofset pliku WAV
			  //lenSample = SAMPLE_m_LEN;				// Dlugość
			  //stanSample = 1;						// Start odtwarzania
				  break;
			  case 1:
			  case 3:
			  case 4:
				  pSample = (uint8_t *)SAMPLE_a_DATA;	// Adres sampli
				  pSample += SAMPLE_a_OFS;				// Ofset pliku WAV
				  lenSample = SAMPLE_a_LEN;				// Dlugość
				  stanSample = 1;						// Start odtwarzania

				  timPlayPause = 0;
				  break;
			  case 2:
			  case 5:
				  pSample = (uint8_t *)SAMPLE_s_DATA;	// Adres sampli
				  pSample += SAMPLE_s_OFS;				// Ofset pliku WAV
				  lenSample = SAMPLE_s_LEN;				// Dlugość
				  stanSample = 1;						// Start odtwarzania

				  timPlayPause = 0;
				  break;
			  case 6:
				  timPlayPause = 3000;
				  break;
			  }
			  nrKomunikatu++;
			  if( nrKomunikatu > 6 ) nrKomunikatu=0;
			  */

			  __NOP();
		  }
	  }



	  /* Enter Stop Mode */
		__HAL_PWR_CLEAR_FLAG(PWR_FLAG_WUF1);    // INFO: bez tego nie da sie wypudzic CPU
//		HAL_PWR_EnterSTOPMode(PWR_LOWPOWERREGULATOR_ON, PWR_STOPENTRY_WFI);
	  __NOP();
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Configure the main internal regulator output voltage 
  */
  HAL_PWREx_ControlVoltageScaling(PWR_REGULATOR_VOLTAGE_SCALE1);
  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSI|RCC_OSCILLATORTYPE_LSI;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.HSIDiv = RCC_HSI_DIV1;
  RCC_OscInitStruct.HSICalibrationValue = RCC_HSICALIBRATION_DEFAULT;
  RCC_OscInitStruct.LSIState = RCC_LSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSI;
  RCC_OscInitStruct.PLL.PLLM = RCC_PLLM_DIV1;
  RCC_OscInitStruct.PLL.PLLN = 8;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV2;
  RCC_OscInitStruct.PLL.PLLQ = RCC_PLLQ_DIV2;
  RCC_OscInitStruct.PLL.PLLR = RCC_PLLR_DIV8;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_0) != HAL_OK)
  {
    Error_Handler();
  }
}

/**
  * @brief IWDG Initialization Function
  * @param None
  * @retval None
  */
static void MX_IWDG_Init(void)
{

  /* USER CODE BEGIN IWDG_Init 0 */

  /* USER CODE END IWDG_Init 0 */

  /* USER CODE BEGIN IWDG_Init 1 */

  /* USER CODE END IWDG_Init 1 */
  hiwdg.Instance = IWDG;
  hiwdg.Init.Prescaler = IWDG_PRESCALER_256;
  hiwdg.Init.Window = 4095;
  hiwdg.Init.Reload = 4095;
  if (HAL_IWDG_Init(&hiwdg) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN IWDG_Init 2 */

  /* USER CODE END IWDG_Init 2 */

}

/**
  * @brief TIM3 Initialization Function
  * @param None
  * @retval None
  */
static void MX_TIM3_Init(void)
{

  /* USER CODE BEGIN TIM3_Init 0 */

  /* USER CODE END TIM3_Init 0 */

  TIM_ClockConfigTypeDef sClockSourceConfig = {0};
  TIM_MasterConfigTypeDef sMasterConfig = {0};
  TIM_OC_InitTypeDef sConfigOC = {0};

  /* USER CODE BEGIN TIM3_Init 1 */

  /* USER CODE END TIM3_Init 1 */
  htim3.Instance = TIM3;
  htim3.Init.Prescaler = 1;
  htim3.Init.CounterMode = TIM_COUNTERMODE_UP;
  htim3.Init.Period = 255;
  htim3.Init.ClockDivision = TIM_CLOCKDIVISION_DIV1;
  htim3.Init.AutoReloadPreload = TIM_AUTORELOAD_PRELOAD_ENABLE;
  if (HAL_TIM_Base_Init(&htim3) != HAL_OK)
  {
    Error_Handler();
  }
  sClockSourceConfig.ClockSource = TIM_CLOCKSOURCE_INTERNAL;
  if (HAL_TIM_ConfigClockSource(&htim3, &sClockSourceConfig) != HAL_OK)
  {
    Error_Handler();
  }
  if (HAL_TIM_PWM_Init(&htim3) != HAL_OK)
  {
    Error_Handler();
  }
  sMasterConfig.MasterOutputTrigger = TIM_TRGO_RESET;
  sMasterConfig.MasterSlaveMode = TIM_MASTERSLAVEMODE_DISABLE;
  if (HAL_TIMEx_MasterConfigSynchronization(&htim3, &sMasterConfig) != HAL_OK)
  {
    Error_Handler();
  }
  sConfigOC.OCMode = TIM_OCMODE_PWM1;
  sConfigOC.Pulse = 25;
  sConfigOC.OCPolarity = TIM_OCPOLARITY_HIGH;
  sConfigOC.OCFastMode = TIM_OCFAST_DISABLE;
  if (HAL_TIM_PWM_ConfigChannel(&htim3, &sConfigOC, TIM_CHANNEL_3) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN TIM3_Init 2 */

  /* USER CODE END TIM3_Init 2 */
  HAL_TIM_MspPostInit(&htim3);

}

/**
  * @brief TIM14 Initialization Function
  * @param None
  * @retval None
  */
static void MX_TIM14_Init(void)
{

  /* USER CODE BEGIN TIM14_Init 0 */

  /* USER CODE END TIM14_Init 0 */

  /* USER CODE BEGIN TIM14_Init 1 */

  /* USER CODE END TIM14_Init 1 */
  htim14.Instance = TIM14;
  htim14.Init.Prescaler = 1;
  htim14.Init.CounterMode = TIM_COUNTERMODE_UP;
  htim14.Init.Period = 65535;
  htim14.Init.ClockDivision = TIM_CLOCKDIVISION_DIV1;
  htim14.Init.AutoReloadPreload = TIM_AUTORELOAD_PRELOAD_ENABLE;
  if (HAL_TIM_Base_Init(&htim14) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN TIM14_Init 2 */

  /* USER CODE END TIM14_Init 2 */

}

/**
  * @brief GPIO Initialization Function
  * @param None
  * @retval None
  */
static void MX_GPIO_Init(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOB_CLK_ENABLE();
  __HAL_RCC_GPIOA_CLK_ENABLE();

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(LD2_GPIO_Port, LD2_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pin : PB7 */
  GPIO_InitStruct.Pin = GPIO_PIN_7;
  GPIO_InitStruct.Mode = GPIO_MODE_IT_RISING_FALLING;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);

  /*Configure GPIO pin : LD2_Pin */
  GPIO_InitStruct.Pin = LD2_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(LD2_GPIO_Port, &GPIO_InitStruct);

  /* EXTI interrupt init*/
  HAL_NVIC_SetPriority(EXTI4_15_IRQn, 0, 0);
  HAL_NVIC_EnableIRQ(EXTI4_15_IRQn);

}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */

  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{ 
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
